﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using DotNetNuke.Entities.Tabs;
using System.Collections;

using System.Collections.Generic;
using DotNetNuke.Common.Utilities;
using DotNetNuke.Entities.Users;

namespace Satrabel.HttpModules.Provider
{
    public class CtlUrlRuleProvider : UrlRuleProvider
    {
        public CtlUrlRuleProvider() {}

        public override List<UrlRule> GetRules(int PortalId)
        {
            List<UrlRule> Rules = new List<UrlRule>();
            Rules.Add(AddRule(PortalId, "terms"));
            Rules.Add(AddRedirect(PortalId, "terms"));
            Rules.Add(AddRule(PortalId, "privacy"));
            Rules.Add(AddRedirect(PortalId, "privacy"));
            Rules.Add(AddRule(PortalId, "login"));
            Rules.Add(AddRule(PortalId, "register"));
            return Rules;
        }

        private static UrlRule AddRule(int PortalId, string ctlName)
        {
            var rule = new UrlRule
            {
                TabId = -1,
                RuleType = UrlRuleType.Module,
                Parameters = "ctl="+ctlName,
                RemoveTab = true,
                Action = UrlRuleAction.Rewrite,
                Url = ctlName
            };                                            
            return rule;
        }

        private static UrlRule AddRedirect(int PortalId, string ctlName)
        {
            var rule = new UrlRule
            {
                TabId = -1,
                RuleType = UrlRuleType.Module,
                Parameters = "ctl=" + ctlName,
                RemoveTab = true,
                Action = UrlRuleAction.Redirect,
                Url = "ctl/"+ctlName,
                RedirectStatus = 301
                //RedirectDestination = ctlName
            };
            return rule;
        }
    }
}